;------------------------------------------
; Solar Assembler test file
;
; test PE64 output
;------------------------------------------
.use64

;------------
; imports
;------------
from kernel32.dll
	import	ExitProcess
	import	GetModuleHandle		alias GetModuleHandleA
	import	LoadLibrary		alias LoadLibraryA
	import	GetProcAddress		;alias GetProcAddressA
	import	FreeLibrary	

;---------------
; sections
;---------------
section 	"code" 		class_code
section 	"data" 		class_data
section 	"idata"		class_imports
section		"reloc"		class_relocs

;-----------------
; program text
;-----------------
.data
	msg_01		db	"Test DLL dynamic load",0

	dll_name	db	"test_dll_64.dll",0
	fn_name_01	db	"api_01",0
	fn_name_02	db	"api_02",0
	
	align 8
	
	dll_handle	dq	0
	fn_ptr_01	dq	0
	fn_ptr_02	dq	0
	
.code


option proc_abi win64 ;stdcall
option proc_align 4


.entry Start

	; force proc align
	nop
	nop

proc test_01 
	uses	rsi,rdi
	arg	a_arg1, a_arg2

	
	mov	rax,[a_arg1]
	mov	rdx,[a_arg2]
	
	nop
	
	ret
endp



Start:
	; align stack on entry
	sub	rsp,8
	
	; this is win64 / stdcall because of "option proc_abi ..." above
	invoke	test_01,1,2
	
	nop
	
	invoke	LoadLibrary,dll_name
	.if rax == 0
		; error
		jmp finish
	.endif

	mov	[dll_handle],rax
	
	invoke	GetProcAddress,[dll_handle],fn_name_01
	.if rax == 0
		; error
		jmp finish
	.endif

	mov	[fn_ptr_01],rax
	

	invoke	GetProcAddress,[dll_handle],fn_name_02
	.if rax == 0
		; error
		jmp finish
	.endif

	mov	[fn_ptr_02],rax	

	; call functions from loaded DLL
	
	mov	rbx,[fn_ptr_01]
	
	invoke	win64,rbx,1,2
	
	;invoke	win64,rbx
	;invoke	cdecl,rbx
	;invoke	lin64,rbx
	
	
	mov	rax,[fn_ptr_02]
	invoke	rax	


finish:
	.if [dll_handle] != 0
		invoke	FreeLibrary,[dll_handle]
	.endif
	
	invoke	ExitProcess,0
	ret



